/*
 * File: app/view/MyViewport.js
 *
 * This file was generated by Sencha Designer version 2.0.0.
 * http://www.sencha.com/products/designer/
 *
 * This file requires use of the Ext JS 4.0.x library, under independent license.
 * License of Sencha Designer does not include license for Ext JS 4.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('MyApp.view.MyViewport', {
    extend: 'Ext.container.Viewport',


    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'panel',
                    autoShow: true,
                    margin: '10 10 10 10',
                    width: 892,
                    layout: {
                        type: 'fit'
                    },
                    title: 'Text Reformatter From PeterKellner.net  (copyright 2012)               http://reformatter.peterkellner.net/',
                    items: [
                        {
                            xtype: 'textareafield',
                            border: 1,
                            height: 230,
                            id: 'BeforeFormatTextAreaId',
                            width: 828,
                            fieldLabel: 'Put Text Here To Be Reformatted',
                            growMin: 100
                        },
                        {
                            xtype: 'textareafield',
                            border: 1,
                            height: 339,
                            id: 'AfterFormatTextAreaId',
                            margin: '',
                            width: 829,
                            fieldLabel: 'After Button Pressed'
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'top',
                            items: [
                                {
                                    xtype: 'button',
                                    id: 'ReformatTextId',
                                    text: 'ReFormat Text',
                                    listeners: {
                                        click: {
                                            fn: me.onReformatTextIdClick,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'tbspacer',
                                    width: 60
                                },
                                {
                                    xtype: 'numberfield',
                                    id: 'outputwidthid',
                                    width: 326,
                                    fieldLabel: 'Output Width',
                                    emptyText: 30,
                                    maxValue: 200,
                                    minValue: 10
                                },
                                {
                                    xtype: 'tbspacer',
                                    width: 20
                                },
                                {
                                    xtype: 'fieldcontainer',
                                    height: 20,
                                    defaultType: 'radiofield',
                                    layout: {
                                        align: 'stretch',
                                        type: 'hbox'
                                    },
                                    flex: 1,
                                    items: [
                                        {
                                            xtype: 'radiofield',
                                            id: 'stringbuilderid',
                                            name: 'outputtype',
                                            boxLabel: 'StringBuilder',
                                            checked: true
                                        },
                                        {
                                            xtype: 'radiofield',
                                            id: 'javascriptarrayid',
                                            name: 'outputtype',
                                            boxLabel: 'JavaScript Array'
                                        },
                                        {
                                            xtype: 'radiofield',
                                            id: 'noformattingid',
                                            name: 'outputtype',
                                            boxLabel: 'No Formatting'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onReformatTextIdClick: function(button, e, options) {

        var beforeTextAreaComponent = Ext.getCmp('BeforeFormatTextAreaId');
        textBefore = beforeTextAreaComponent.getValue();

        // how to not pollute global name space here?
        var stringbuildervalue = Ext.getCmp('stringbuilderid').getValue();
        var javascriptarrayvalue = Ext.getCmp('javascriptarrayid').getValue();
        var noformattingvalue = Ext.getCmp('noformattingid').getValue();
        var outputwidthvalue = Ext.getCmp('outputwidthid').getValue();

        Ext.Ajax.request({
            url: 'ReFormatter/ConvertTextToFriendlyText',
            params: {
                inputText: textBefore,
                stringbuilder: stringbuildervalue,
                javascriptarray: javascriptarrayvalue,
                noformatting: noformattingvalue,
                outputwidth: outputwidthvalue
            },
            success: function(response){
                var localData = Ext.JSON.decode(response.responseText).Data;
                var numberRows = localData.length;
                var newData = '';
                for (var i=0;i<numberRows;i++) {
                    newData += localData[i] + '\n';
                }


                var afterTextAreaComponent = Ext.getCmp('AfterFormatTextAreaId');
                afterTextAreaComponent.setValue(newData);

            },
            failure: function(error) {
                alert('error');
            }

        });


    }

});